Debian Bug report logs - #513073
debhelper impossible to unpack on Win32 due to case insensitivity

version graph

Package: debhelper; Maintainer for debhelper is Debhelper Maintainers <debhelper-devel@lists.alioth.debian.org>; Source for debhelper is src:debhelper.

Reported by: Sjors Gielen <dazjorz@dazjorz.com>

Date: Mon, 26 Jan 2009 05:48:01 UTC

Severity: normal

Found in version debhelper/7.0.17

Done: Joey Hess <joeyh@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#513073; Package debhelper. (Mon, 26 Jan 2009 05:48:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sjors Gielen <dazjorz@dazjorz.com>:
New Bug report received and forwarded. Copy sent to Joey Hess <joeyh@debian.org>. (Mon, 26 Jan 2009 05:48:03 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Sjors Gielen <dazjorz@dazjorz.com>
To: submit@bugs.debian.org
Cc: debian-kcygwin-devel@lists.sourceforge.net
Subject: debhelper impossible to unpack on Win32 due to case insensitivity
Date: Mon, 26 Jan 2009 06:46:13 +0100 (CET)
Package: debhelper
Version: 7.0.17

Hey all,

The debhelper package contains both a 'debian' directory for debian/rules etc and a
'Debian' directory for the Debian/Debhelper/*.pm Perl modules. Therefore, on Win32
(i.e. Cygwin), it is impossible to unpack debhelper - when you try, you get only the
debian/ folder, so the modules are missing.

A patch is available in the Debian GNU/kCygwin project SVN repository on Sourceforge.
For reference, I've also added it below.

Apart from applying this patch, the Debian directory should be moved to lib/Debian, of
course.

Only in debhelper-orig: Debian
Only in debhelper: lib
diff -ur debhelper-orig/Makefile debhelper/Makefile
--- debhelper-orig/Makefile	2008-07-31 18:27:07.000000000 +0200
+++ debhelper/Makefile	2009-01-26 06:36:26.000000000 +0100
@@ -51,10 +51,10 @@
 
 version:
 	printf "package Debian::Debhelper::Dh_Version;\n\$$version='$(VERSION)';\n1" > \
-		Debian/Debhelper/Dh_Version.pm
+		lib/Debian/Debhelper/Dh_Version.pm
 
 clean:
-	rm -f *.1 *.7 Debian/Debhelper/Dh_Version.pm
+	rm -f *.1 *.7 lib/Debian/Debhelper/Dh_Version.pm
 	po4a --rm-translations --rm-backups man/po4a/po4a.cfg
 	for lang in $(LANGS); do \
 		if [ -e man/$$lang ]; then rmdir man/$$lang; fi; \
@@ -66,8 +66,8 @@
 		$(DESTDIR)$(PERLLIBDIR)/Sequence
 	install $(shell find -maxdepth 1 -mindepth 1 -name dh\* |grep -v \.1\$$) $(DESTDIR)/usr/bin
 	install -m 0644 autoscripts/* $(DESTDIR)/usr/share/debhelper/autoscripts
-	install -m 0644 Debian/Debhelper/*.pm $(DESTDIR)$(PERLLIBDIR)
-	install -m 0644 Debian/Debhelper/Sequence/*.pm $(DESTDIR)$(PERLLIBDIR)/Sequence
+	install -m 0644 lib/Debian/Debhelper/*.pm $(DESTDIR)$(PERLLIBDIR)
+	install -m 0644 lib/Debian/Debhelper/Sequence/*.pm $(DESTDIR)$(PERLLIBDIR)/Sequence
 
 test: version
 	./run perl -MTest::Harness -e 'runtests grep { ! /CVS/ && ! /\.svn/ } @ARGV' t/*
diff -ur debhelper-orig/run debhelper/run
--- debhelper-orig/run	2008-07-31 18:27:07.000000000 +0200
+++ debhelper/run	2009-01-26 06:36:04.000000000 +0100
@@ -7,7 +7,7 @@
 
 # Ensure that builds are self-hosting, which means I have to use the .pm
 # files in this package, not any that may be on the system.
-export PERL5LIB=$(pwd)
+export PERL5LIB=$(pwd)/lib
 
 # If any automatic script generation is done in building this package, 
 # be sure to use the new templates from this package.




Reply sent to Joey Hess <joeyh@debian.org>:
You have taken responsibility. (Mon, 26 Jan 2009 06:21:16 GMT) Full text and rfc822 format available.

Notification sent to Sjors Gielen <dazjorz@dazjorz.com>:
Bug acknowledged by developer. (Mon, 26 Jan 2009 06:21:16 GMT) Full text and rfc822 format available.

Message #10 received at 513073-done@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
Cc: 513073-done@bugs.debian.org
Subject: Re: Bug#513073: debhelper impossible to unpack on Win32 due to case insensitivity
Date: Mon, 26 Jan 2009 01:20:29 -0500
Sjors Gielen wrote:
> The debhelper package contains both a 'debian' directory for debian/rules etc and a
> 'Debian' directory for the Debian/Debhelper/*.pm Perl modules. Therefore, on Win32
> (i.e. Cygwin), it is impossible to unpack debhelper - when you try, you get only the
> debian/ folder, so the modules are missing.
> 
> A patch is available in the Debian GNU/kCygwin project SVN repository on Sourceforge.
> For reference, I've also added it below.
> 
> Apart from applying this patch, the Debian directory should be moved to lib/Debian, of
> course.

Sorry, but I think I'd rather not worry about compatability with
case-insensative filesystems in debhelper.
 
-- 
see shy jo




Information forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#513073; Package debhelper. (Mon, 26 Jan 2009 06:42:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sjors Gielen <dazjorz@dazjorz.com>:
Extra info received and forwarded to list. Copy sent to Joey Hess <joeyh@debian.org>. (Mon, 26 Jan 2009 06:42:07 GMT) Full text and rfc822 format available.

Message #15 received at 513073@bugs.debian.org (full text, mbox):

From: Sjors Gielen <dazjorz@dazjorz.com>
To: 513073@bugs.debian.org
Cc: debian-kcygwin-devel@lists.sourceforge.net
Subject: Re: Bug#513073 closed by Joey Hess <joeyh@debian.org> (Re: Bug#513073: debhelper impossible to unpack on Win32 due to case insensitivity)
Date: Mon, 26 Jan 2009 07:38:57 +0100
Debian Bug Tracking System schreef:
> Sjors Gielen wrote:
>> The debhelper package contains both a 'debian' directory for debian/rules etc and a
>> 'Debian' directory for the Debian/Debhelper/*.pm Perl modules. Therefore, on Win32
>> (i.e. Cygwin), it is impossible to unpack debhelper - when you try, you get only the
>> debian/ folder, so the modules are missing.
>>
>> A patch is available in the Debian GNU/kCygwin project SVN repository on Sourceforge.
>> For reference, I've also added it below.
>>
>> Apart from applying this patch, the Debian directory should be moved to lib/Debian, of
>> course.
> 
> Sorry, but I think I'd rather not worry about compatability with
> case-insensative filesystems in debhelper.

Why? I'm trying to port Debian to Cygwin. It matters here. And I've 
already supplied you with a patch, which does not break things anywhere; 
 removes the uglyness of having two directories with the same name 
case-insensitively; and adds Cygwin and Win32 as platforms to build 
debhelper on. The fact you'll never build it on there, is unimportant in 
this case.

- Sjors




Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#513073; Package debhelper. (Mon, 26 Jan 2009 07:00:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joeyh@debian.org>:
Extra info received and forwarded to list. (Mon, 26 Jan 2009 07:00:03 GMT) Full text and rfc822 format available.

Message #20 received at 513073@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: Sjors Gielen <dazjorz@dazjorz.com>, 513073@bugs.debian.org
Cc: debian-kcygwin-devel@lists.sourceforge.net
Subject: Re: Bug#513073: closed by Joey Hess <joeyh@debian.org> (Re: Bug#513073: debhelper impossible to unpack on Win32 due to case insensitivity)
Date: Mon, 26 Jan 2009 01:57:02 -0500
[Message part 1 (text/plain, inline)]
Sjors Gielen wrote:
> Why? I'm trying to port Debian to Cygwin. It matters here. And I've  
> already supplied you with a patch, which does not break things anywhere;  
>  removes the uglyness of having two directories with the same name  
> case-insensitively; and adds Cygwin and Win32 as platforms to build  
> debhelper on. The fact you'll never build it on there, is unimportant in  
> this case.

You're implicitly asking me to take care to avoid the case of files that
differ only in case, which would be an ongoing effort, for no appreciable
benefit.

-- 
see shy jo
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#513073; Package debhelper. (Mon, 26 Jan 2009 09:36:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sjors Gielen <dazjorz@dazjorz.com>:
Extra info received and forwarded to list. Copy sent to Joey Hess <joeyh@debian.org>. (Mon, 26 Jan 2009 09:36:04 GMT) Full text and rfc822 format available.

Message #25 received at 513073@bugs.debian.org (full text, mbox):

From: Sjors Gielen <dazjorz@dazjorz.com>
To: Joey Hess <joeyh@debian.org>
Cc: 513073@bugs.debian.org, debian-kcygwin-devel@lists.sourceforge.net
Subject: Re: Bug#513073: closed by Joey Hess <joeyh@debian.org> (Re: Bug#513073: debhelper impossible to unpack on Win32 due to case insensitivity)
Date: Mon, 26 Jan 2009 10:34:22 +0100
Joey Hess schreef:
> You're implicitly asking me to take care to avoid the case of files that
> differ only in case, which would be an ongoing effort, for no appreciable
> benefit.
> 

I'm asking you to apply this patch to make it possible for users with 
case-insensitive filesystems to install debhelper, nothing else. It is 
not your responsibility to keep debhelper working on case insensitive 
filesystems, but it would be ignorant to not apply a patch that fixes 
this and creates no new problems. Any subsequent change that is required 
to keep debhelper and other packages working on case insensitive 
filesystems will not be your responsibility, and by applying this patch 
you are not taking that responsibility.

The benefit is not appreciable to you, mind you. And Windows is not the 
only case insensitive platform. How does this work on the Mac? Is it 
possible to unpack, let alone compile, debhelper on OS X?

- Sjors




Information forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#513073; Package debhelper. (Thu, 12 Feb 2009 21:33:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sjors Gielen <dazjorz@dazjorz.com>:
Extra info received and forwarded to list. Copy sent to Joey Hess <joeyh@debian.org>. (Thu, 12 Feb 2009 21:33:02 GMT) Full text and rfc822 format available.

Message #30 received at 513073@bugs.debian.org (full text, mbox):

From: Sjors Gielen <dazjorz@dazjorz.com>
To: 513073@bugs.debian.org
Subject: Status update on #513073 - debhelper impossible to unpack on Win32 due to case insensitivity
Date: Thu, 12 Feb 2009 22:31:25 +0100
Hey all,

I'm wondering about the status of this bug. A patch has been supplied 
which fixes a problem as seen on Cygwin. Has it been committed yet? Can 
the bug be closed?

Sjors




Information forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#513073; Package debhelper. (Tue, 24 Feb 2009 22:09:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sjors Gielen <mailinglist@dazjorz.com>:
Extra info received and forwarded to list. Copy sent to Joey Hess <joeyh@debian.org>. (Tue, 24 Feb 2009 22:09:02 GMT) Full text and rfc822 format available.

Message #35 received at 513073@bugs.debian.org (full text, mbox):

From: Sjors Gielen <mailinglist@dazjorz.com>
To: Joey Hess <joeyh@debian.org>
Cc: debian-devel@lists.debian.org, 513073@bugs.debian.org, debian-kcygwin-devel@lists.sourceforge.net
Subject: Bug #513073 - debhelper impossible to unpack on Win32 due to case insensitivity - please reopen
Date: Tue, 24 Feb 2009 23:07:35 +0100
Hello Joey and list,

I'd like to ask you to reopen this bug. I have sent you a patch which 
fixes debhelper so it can unpack on case insensitive file systems or 
operating systems. debhelper has in its main directory, next to the 
regular debian directory, also a Debian directory which contains Perl 
modules.  The patch (see the original bug report) fixes this case 
conflict by moving the Debian directory to lib/.

The main argument not to apply this patch was, that by applying it it 
becomes your reponsibility to keep debhelper working on Win32. That's 
not the case, because there are other people to keep checking 
compatibility for you, like me and other users who would want debhelper 
to work on their platform.

If I'm correct, OS X may work in case insensitive mode too. Other than 
that, I am already trying to get Debian packages to work under Cygwin. I 
can confirm the patch makes debhelper unpack cleanly. As far as I'm 
aware the patch does not break anything on other platforms (please tell 
me if I'm wrong).

I'm cc'ing the list to hear their opinion on this matter. If they agree 
the patch should not be applied, I will create a seperate source package 
just for debhelper on Cygwin.

Thank you,
Sjors




Information forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#513073; Package debhelper. (Tue, 24 Feb 2009 22:27:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
Extra info received and forwarded to list. Copy sent to Joey Hess <joeyh@debian.org>. (Tue, 24 Feb 2009 22:27:05 GMT) Full text and rfc822 format available.

Message #40 received at 513073@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: Sjors Gielen <mailinglist@dazjorz.com>
Cc: Joey Hess <joeyh@debian.org>, debian-devel@lists.debian.org, 513073@bugs.debian.org, debian-kcygwin-devel@lists.sourceforge.net
Subject: Re: Bug #513073 - debhelper impossible to unpack on Win32 due to case insensitivity - please reopen
Date: Tue, 24 Feb 2009 22:24:46 +0000
[Message part 1 (text/plain, inline)]
On Tue, 24 Feb 2009 23:07:35 +0100
Sjors Gielen <mailinglist@dazjorz.com> wrote:

> I'd like to ask you to reopen this bug. I have sent you a patch which 
> fixes debhelper so it can unpack on case insensitive file systems or 
> operating systems. debhelper has in its main directory, next to the 
> regular debian directory, also a Debian directory which contains Perl 
> modules.  The patch (see the original bug report) fixes this case 
> conflict by moving the Debian directory to lib/.

Even if only looking at perl packages installed on my own machine, this
problem is not unique to debhelper - any package that has a Debian::
perl module is likely to have exactly the same "problem"/feature.

$ ls /usr/share/perl5/Debian
AdduserCommon.pm  Debhelper        Dependency.pm          DpkgCross.pm
AptContents.pm    Defoma           DictionariesCommon.pm  Dwww
DebConf           Dependencies.pm  DocBase                Packages

> If I'm correct, OS X may work in case insensitive mode too.

It's been a while since I used OSX but I certainly remember .DS_Store
directories all over the place and various applications using a mix of
capitalised and lower case directory names.

-- 


Neil Williams
=============
http://www.data-freedom.org/
http://www.linux.codehelp.co.uk/
http://e-mail.is-not-s.ms/

[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#513073; Package debhelper. (Tue, 24 Feb 2009 22:36:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Cyril Brulebois <kibi@debian.org>:
Extra info received and forwarded to list. Copy sent to Joey Hess <joeyh@debian.org>. (Tue, 24 Feb 2009 22:36:04 GMT) Full text and rfc822 format available.

Message #45 received at 513073@bugs.debian.org (full text, mbox):

From: Cyril Brulebois <kibi@debian.org>
To: Sjors Gielen <mailinglist@dazjorz.com>, Joey Hess <joeyh@debian.org>, debian-devel@lists.debian.org, 513073@bugs.debian.org, debian-kcygwin-devel@lists.sourceforge.net
Subject: Re: Bug #513073 - debhelper impossible to unpack on Win32 due to case insensitivity - please reopen
Date: Tue, 24 Feb 2009 23:32:26 +0100
[Message part 1 (text/plain, inline)]
Neil Williams <codehelp@debian.org> (24/02/2009):
> > If I'm correct, OS X may work in case insensitive mode too.
> 
> It's been a while since I used OSX but I certainly remember .DS_Store
> directories all over the place and various applications using a mix of
> capitalised and lower case directory names.

See HFS, HFS+, HFSX, etc. With some setups, you indeed have .DS_Store,
but you can't rename it as .ds_store, because that'd be the same file.
Moving it from .DS_Store to fubar and then back to .ds_store works,
though.

Mraw,
KiBi.
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#513073; Package debhelper. (Tue, 24 Feb 2009 23:42:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sjors Gielen <mailinglist@dazjorz.com>:
Extra info received and forwarded to list. Copy sent to Joey Hess <joeyh@debian.org>. (Tue, 24 Feb 2009 23:42:06 GMT) Full text and rfc822 format available.

Message #50 received at 513073@bugs.debian.org (full text, mbox):

From: Sjors Gielen <mailinglist@dazjorz.com>
To: Neil Williams <codehelp@debian.org>
Cc: debian-devel@lists.debian.org, debian-kcygwin-devel@lists.sourceforge.net, 513073@bugs.debian.org
Subject: Re: Bug #513073 - debhelper impossible to unpack on Win32 due to case insensitivity - please reopen
Date: Wed, 25 Feb 2009 00:38:03 +0100
Neil Williams schreef:
> On Tue, 24 Feb 2009 23:07:35 +0100
> Sjors Gielen <mailinglist@dazjorz.com> wrote:
> 
>> I'd like to ask you to reopen this bug. I have sent you a patch which 
>> fixes debhelper so it can unpack on case insensitive file systems or 
>> operating systems. debhelper has in its main directory, next to the 
>> regular debian directory, also a Debian directory which contains Perl 
>> modules.  The patch (see the original bug report) fixes this case 
>> conflict by moving the Debian directory to lib/.
> 
> Even if only looking at perl packages installed on my own machine, this
> problem is not unique to debhelper - any package that has a Debian::
> perl module is likely to have exactly the same "problem"/feature.
> 
> $ ls /usr/share/perl5/Debian
> AdduserCommon.pm  Debhelper        Dependency.pm          DpkgCross.pm
> AptContents.pm    Defoma           DictionariesCommon.pm  Dwww
> DebConf           Dependencies.pm  DocBase                Packages

Not really. For example the Defoma directory there:

  defoma-0.11.10$ find . -name '*.pm'
  ./pm/Defoma/SubstCache.pm
  [...]

DocBase:

  doc-base-0.8.20$ find . -name '*.pm'
  ./perl/Debian/DocBase/Document.pm

This is a problem of packaging only. For debhelper, this is the current 
situation:

  debhelper-7.0.15$ find . -name '*.pm'
  ./Debian/Debhelper/Sequence/python_support.pm

As you see, the Debian dir here conflicts with the regular debian 
directory on case insensitive filesystems.

>> If I'm correct, OS X may work in case insensitive mode too.
> 
> It's been a while since I used OSX but I certainly remember .DS_Store
> directories all over the place and various applications using a mix of
> capitalised and lower case directory names.

So this would not only help debhelper on Win32 platforms, but also on OS 
X in some configurations.

Sjors




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Wed, 25 Mar 2009 07:29:40 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 16 19:10:34 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.